*** linux-2.0.28/net/ipv4/tcp.c	Tue Nov 26 23:44:11 1996
--- KERNEL/net/ipv4/tcp.c	Mon Nov 24 22:52:47 1997
***************
*** 435,444 ****
  
  #include <asm/segment.h>
  
  unsigned long seq_offset;
  struct tcp_mib	tcp_statistics;
  
! static void tcp_close(struct sock *sk, unsigned long timeout);
  
  /*
   *	Find someone to 'accept'. Must be called with
--- 435,448 ----
  
  #include <asm/segment.h>
  
+ extern struct sock *TCP_scansock;
+ void remove_sock(struct sock *sk);
+ static int tcp_close_state(struct sock *sk, int dead);
+ 
  unsigned long seq_offset;
  struct tcp_mib	tcp_statistics;
  
! void tcp_close(struct sock *sk, unsigned long timeout);
  
  /*
   *	Find someone to 'accept'. Must be called with
***************
*** 453,459 ****
  	do
  	{
  		if(p->sk->state == TCP_ESTABLISHED || p->sk->state >= TCP_FIN_WAIT1)
! 			return p;
  		p=p->next;
  	}
  	while(p!=(struct sk_buff *)&s->receive_queue);
--- 457,470 ----
  	do
  	{
  		if(p->sk->state == TCP_ESTABLISHED || p->sk->state >= TCP_FIN_WAIT1)
! 		{
! 			/* Scanned socks: both socks in the pair must be */
! 			/* at or beyond ESTABLISHED before being accepted. */
! 			struct sock *sk2 = p->sk->scanpair;
! 			if(!sk2 || (sk2->state != TCP_SYN_RECV &&
! 					sk2->state != TCP_SYN_SENT))
! 				return p;
! 		}
  		p=p->next;
  	}
  	while(p!=(struct sk_buff *)&s->receive_queue);
***************
*** 493,498 ****
--- 504,535 ----
  
  
  /*
+  * Part of the general protection scheme is to make sure we are not
+  * processing a packet on a sock that can be destroyed by the TIME_DONE
+  * timer.  This means we must clear_backlog() before we
+  * tcp_set_state(TCP_CLOSE).  Do not remove_sock() because now get_sock()
+  * will skip TCP socks in TCP_CLOSE state.  This reduces races between
+  * the backlog and the TIME_DONE timer and lets the sock remain visible
+  * to netstat and WSsocklog until really destroyed.
+  *
+  * This pre-TCP_CLOSE routine is now called in the numerous places
+  * we were not correctly protecting ourselves.
+  */
+ void tcp_preclose(struct sock *sk)
+ {
+ 	struct sock *sk2 = sk->scanpair;
+ 	void clear_backlog(struct sock *sk);
+ 
+ 
+ 	sk->scanpair = NULL;
+ 	if (sk2)
+ 		sk2->scanpair = NULL;
+ 
+ 	clear_backlog(sk);
+ }
+ 
+ 
+ /*
   * This routine is called by the ICMP module when it gets some
   * sort of error condition.  If err < 0 then the socket should
   * be closed and the error returned to the user.  If err > 0
***************
*** 585,590 ****
--- 622,628 ----
  			if (sk->state == TCP_SYN_SENT || sk->state == TCP_SYN_RECV)
  			{
  				tcp_statistics.TcpAttemptFails++;
+ 				tcp_preclose(sk);
  				tcp_set_state(sk,TCP_CLOSE);
  				sk->error_report(sk);		/* Wake people up to see the error (see connect in sock.c) */
  			}
***************
*** 743,748 ****
--- 781,1150 ----
  	return 0;
  }
  
+ /*
+  * The application requests file descriptor access to
+  * the other sock in a scanned pair.
+  */
+ int tcp_scan_accept(struct sock *sk)
+ {
+ 	struct socket *sock, *newsock;
+ 	struct sock *sk2;
+ 	extern int get_fd(struct inode *);
+ 	int fd;
+ 
+ 	lock_sock(sk);
+ 	/* This line mirrors tcp_accept(), which finds an acceptable sock. */
+ 	sk2 = sk->scanpair;
+ 	if (!sk2 || sk2->scanaccepted) {
+ 		release_sock(sk);
+ 		return(-EINVAL);
+ 	}
+ 
+ 	/* Lock sk2 incase we give up CPU in sock_alloc or below. */
+ 	lock_sock(sk2);
+ 
+ 	if (!(newsock = sock_alloc())) 
+ 	{
+ 		printk("NET: tcp_scan_accept: no more sockets\n");
+ 		release_sock(sk);
+ 		release_sock(sk2);
+ 		return(-ENOSR);	/* Was: EAGAIN, but we are out of system
+ 				   resources! */
+ 	}
+ 	sock = sk->socket;
+ 	newsock->type = sock->type;
+ 	newsock->ops = sock->ops;
+ 
+ 	/* mirror inet_accept after its call to tcp_accept */
+ 	newsock->data = (void *)sk2;
+ 	sk2->sleep = newsock->wait;
+ 	sk2->socket = newsock;
+ 	newsock->conn = NULL; /* AF_UNIX and FIFOs only? */
+ 	newsock->state = SS_CONNECTED;
+ 
+ 	/* done with inet_accept, now mimic sys_accept */
+ 	if ((fd = get_fd(SOCK_INODE(newsock))) < 0) 
+ 	{
+ 		sock_release(newsock);
+ 		release_sock(sk);
+ 		release_sock(sk2);
+ 		return(-EINVAL);
+ 	}
+ 	sock->file=current->files->fd[fd];
+ 
+ 	sk2->scanaccepted = 1;
+ 	release_sock(sk);
+ 	release_sock(sk2);
+ 	/* this gets returned all the way back up to the user */
+ 	return(fd);
+ }
+ 
+ /*
+  * Bridge backlogged packets on a sock cleaned by tcp_dontcare_cleanup().
+  *
+  * If called during the tcp_scan_dontcare() process, this prevents the
+  * subsequent release_sock() from accessing the backlog of a sock that
+  * will be destroyed by its TIME_DONE timer.  The sock lock sk->users
+  * does not protect the sock at that point because release_sock()
+  * releases the lock before processing the backlog.
+  *
+  * If called while processing a sock backlog (either the last ACK has
+  * arrived or a reset forced us to clean up), then this again prevents
+  * us from continuing the backlog processing.
+  *
+  * While we should not even have a backlog while processing a newly
+  * arriving packet, we are still safe in bridging the backlog.
+  *
+  * Below, clear_backlog() drops packets in the backlog.  Sometimes
+  * we do not want to bridge them.
+  */
+ void bridge_backlog(struct sock *sk)
+ {
+ 	extern bridge_xmit(struct sk_buff *skb, struct device *dev, int pri);
+ 	struct sk_buff *skb;
+ 
+   	while((skb = skb_dequeue(&sk->back_log)) != NULL) {
+ 		skb->sk = NULL;
+ 		bridge_xmit(skb, skb->dev, 0);
+ 	}
+ }
+ 
+ void clear_backlog(struct sock *sk)
+ {
+ 	struct sk_buff *skb;
+ 
+   	while((skb = skb_dequeue(&sk->back_log)) != NULL) {
+ 		skb->sk = NULL;
+ 		kfree_skb(skb, FREE_READ);
+ 	}
+ }
+ 
+ /*
+  * Cleanup dontcare socks only when both in the pair have no more
+  * unacked data.  Then get rid of them together.
+  * Added force flag for tcp_reset() to force closure of dontcare socks.
+  */
+ int tcp_dontcare_cleanup(struct sock *sk, int force)
+ {
+ 	log_sockevent(sk, 15, (int)sk->retransmit_timer.next,
+ 		(int)sk->send_head + (int)skb_peek(&sk->write_queue));
+ 	log_sockevent(sk, 17, (int)sk->dead, (int)sk->state);
+ 	/* We should not get here now that tcp_close() does not call this. */
+ 	if(sk->dontcare>1) {
+ 		printk("skip second cleanup on sk %p from %p, %p, %p\n", sk,
+ 			__builtin_return_address(0),
+ 			__builtin_return_address(1),
+ 			__builtin_return_address(2));
+ 		return 0;
+ 	}
+ 
+ 	if((force == 1) || (!sk->send_head && skb_peek(&sk->write_queue) == NULL))
+ 	{
+ 		struct sock *sk2 = sk->scanpair;
+ 		if (!sk2) {
+ 			printk("dontcare cleanup with sk2=NULL\n");
+ 		} else {
+ 			log_sockevent(sk2, 18, (int)sk->dead, (int)sk->dontcare);
+ 		}
+ 		if((sk2 && (sk2->send_head || skb_peek(&sk2->write_queue))) &&
+ 			!force)
+ 			return 0;
+ 
+ 		/* no more acks are needed, so dont accept any more packets */
+ 		remove_sock(sk);
+ 		if(sk2)
+ 			remove_sock(sk2);
+ 		sk->dontcare++; /* so we only get in here once */
+ 		sk->scanpair = NULL;
+ 		bridge_backlog(sk);
+ 		tcp_set_state(sk, TCP_CLOSE);
+ 
+ 		if(sk2 && sk2->dontcare == 1) {
+ 			sk2->dontcare++;
+ 			sk2->scanpair = NULL;
+ 			bridge_backlog(sk2);
+ 			tcp_set_state(sk2, TCP_CLOSE);
+ 		}
+ 		return 1;
+ 	}
+ 	return 0;
+ }
+ 
+ /*
+  * For SIOCSDONTCARE, transfer received packets from one socket
+  * to the write side of the other.
+  */
+ void tcp_dontcare_transfer(struct sock *sk, struct sock *sk2)
+ {
+ 	struct sk_buff *skb;
+ 	int finflag = 0;
+ 
+ 	/* first, flush anything the application has written */
+ 	tcp_send_partial(sk2);
+ 
+ 	/*
+ 	 * This routine does not account for partially read packets.
+ 	 * As it is required (see comments in tcp_scan_dontcare()) for
+ 	 * the application to have previously written any read data,
+ 	 * we will simply be rewriting some of it.
+ 	 * It is OK to retransmit some old data.
+ 	 */
+ 	while((skb=skb_dequeue(&sk->receive_queue)) != NULL)
+ 	{
+ 		if(!before(skb->seq, sk->acked_seq+1))
+ 		{
+ 			/* drop discontiguous (or just unacked) data */
+ 			/* sock_rfree() takes care of counters */
+ 			kfree_skb(skb, FREE_READ);
+ 			continue;
+ 		}
+ 		/* memory allocation accounting */
+ 		atomic_sub(skb->truesize, &sk->rmem_alloc);
+ 		atomic_add(skb->truesize, &sk2->wmem_alloc);
+ 
+ 		/*
+ 		 * Send it over to the other side.
+ 		 *
+ 		 * On the receive_queue, skb->len is the length of TCP data
+ 		 * (not including MAC, IP and TCP headers), and skb->data
+ 		 * points to the TCP data.  Fix these up.
+ 		 * See tcp_data() and tcp_read() for details.
+ 		 * skb->seq is the host formatted sequence number.
+ 		 * Update write_seq so that sent_seq gets updated, else
+ 		 * tcp_ack() will act funny.
+ 		 */
+ 		sk2->write_seq = skb->seq + skb->len;
+ 		skb->csum = csum_partial(skb->data, skb->len, 0);
+ 		skb_push(skb, skb->data-skb->mac.raw);
+ 		if(skb->h.th->fin) {
+ 			finflag = 1;
+ 			sk2->write_seq++;
+ 		}
+ 		skb->sk = sk2;
+ 		skb->free = 0;
+ 		skb->arp = 1;
+ 		skb->dev = sk2->scandev;
+ 		tcp_send_skb(sk2, skb);
+ 	}
+ 	if(sk->state == TCP_CLOSE_WAIT) {
+ 		if(tcp_close_state(sk2, 0) == 0) {
+ 			/* maybe already sent a fin?  should not get here. */
+ 			printk("dontcare_transfer: failed to fin in state %d\n",
+ 				sk2->state);
+ 		} else if(!finflag) {
+ 			tcp_send_fin(sk2);
+ 		}
+ 	}
+ }
+ 
+ /*
+  * The application no longer wishes to scan this connection.
+  * Transfer the receive buffers from each side to the write
+  * buffer on the other side.  Doing this ioctl on either socket
+  * causes both to short circuit.
+  *
+  * This requires the scanning application to have written to each
+  * side exactly as much as was read from the other side.  Writing
+  * too little, the receiver will only send ACK sequences less than
+  * the bottom of the sender's retransmit buffer because the sender
+  * discards what we at one time already ACKed.  This is a hung
+  * connection.  Writing more than what was read is less catastrophic.
+  * In this case, some of the real data gets lost but at least there
+  * is no hung connection.
+  *
+  * Therefore, EADDRNOTAVAIL is returned if the write sequence on
+  * either side is not equal to the read sequence on the other side.
+  */
+ int tcp_scan_dontcare(struct sock *sk)
+ {
+ 	struct sock *sk2;
+ 	int copied, copied2;
+ 
+ 	lock_sock(sk);
+ 	if (sk->dontcare) {
+ 		printk("skip second scan_dontcare\n");
+ 		release_sock(sk);
+ 		return(0); /* so old apps do not fail, should be EALREADY */
+ 	}
+ 	sk2 = sk->scanpair;
+ 	if (!sk2) {
+ 		release_sock(sk);
+ 		return(-EINVAL);
+ 	}
+ 	lock_sock(sk2);
+ 	/* from this point on, tcp_rcv() back_logs incoming packets */
+ 
+ 	/*
+ 	 * Not only must the amount read equal the amount written, but
+ 	 * I must account for FINs.  We must not have sent any FINs
+ 	 * (as that indicates we closed something), but we may have
+ 	 * received and ACKed FINs.  On receiving a FIN, go to CLOSE_WAIT
+ 	 * state.  On reading the FIN, increment the copied_seq and
+ 	 * mark the FIN packet as "used" (and possibly delete it).
+ 	 */
+ 	if((sk->state != TCP_ESTABLISHED && sk->state != TCP_CLOSE_WAIT) ||
+ 	   (sk2->state != TCP_ESTABLISHED && sk2->state != TCP_CLOSE_WAIT)) {
+ 		release_sock(sk);
+ 		release_sock(sk2);
+ 		return(-EINVAL);
+ 	}
+ 	log_sockevent(sk, 7, sk->write_seq, sk->copied_seq);
+ 	log_sockevent(sk2, 8, sk2->write_seq, sk2->copied_seq);
+ 
+ 	/*
+ 	 * When calculating the amount of data read on each side, account
+ 	 * for consumed FINs.  Tcp_recvmsg() increments copied_seq and
+ 	 * sets finflag when a FIN is consumed.  In this way, the
+ 	 * application accidentally consumes an extra octet without
+ 	 * writing it.
+ 	 */
+ 	copied = sk->copied_seq;
+ 	if(sk->state == TCP_CLOSE_WAIT) {
+ 		if(sk->finflag)
+ 			copied--;
+ 	}
+ 	copied2 = sk2->copied_seq;
+ 	if(sk2->state == TCP_CLOSE_WAIT) {
+ 		if(sk2->finflag)
+ 			copied2--;
+ 	}
+ 
+ 	if(sk->write_seq != copied2)
+ 	{
+ 		printk("tcp_scan_dontcare: sk1 fails with write_seq %u != copied_seq %u\n",
+ 			(uint) sk->write_seq, (uint) copied2);
+ 		if (sk->write_seq == copied2 - 1) {
+ 			/* Diagnostics: maybe I lost a FIN count somewhere? */
+ 			struct sk_buff *skb = skb_peek(&sk2->receive_queue);
+ 			printk("  sk2: state=%d, skb_peek()=%p\n",
+ 				sk2->state, skb);
+ 			printk("    copied_seq=%u, list->prev=%p\n",
+ 				sk2->copied_seq, sk2->receive_queue.prev);
+ /* maybe I should print copied_seq and receive_queue.prev? */
+ 			if (skb) {
+ 				printk("    skb: seq=%u, used=%d, fin=%d\n",
+ 					skb->seq, skb->used, skb->h.th->fin);
+ 				printk("    skb: source=%d, dest=%d\n",
+ 					ntohs(skb->h.th->source), ntohs(skb->h.th->dest));
+ 			}
+ 		}
+ 		release_sock(sk);
+ 		release_sock(sk2);
+ 		return(-EADDRNOTAVAIL);
+ 	}
+ 
+ 	if(sk2->write_seq != copied)
+ 	{
+ 		printk("tcp_scan_dontcare: sk2 fails with write_seq %u != copied_seq %u\n",
+ 			(uint) sk2->write_seq, (uint) copied);
+ 		if (sk2->write_seq == copied - 1) {
+ 			/* Diagnostics: maybe I lost a FIN count somewhere? */
+ 			struct sk_buff *skb = skb_peek(&sk->receive_queue);
+ 			printk("  sk: state=%d, skb_peek()=%p\n",
+ 				sk->state, skb);
+ 			printk("  copied_seq=%u, list->prev=%p\n",
+ 				sk->copied_seq, sk->receive_queue.prev);
+ 			if (skb) {
+ 				printk("    skb: seq=%u, used=%d, fin=%d\n",
+ 					skb->seq, skb->used, skb->h.th->fin);
+ 				printk("    skb: source=%d, dest=%d\n",
+ 					ntohs(skb->h.th->source), ntohs(skb->h.th->dest));
+ 			}
+ 		}
+ 		release_sock(sk);
+ 		release_sock(sk2);
+ 		return(-EADDRNOTAVAIL);
+ 	}
+ 
+ 	sk->dontcare = sk2->dontcare = 1;
+ 
+ 	tcp_dontcare_transfer(sk, sk2);
+ 	tcp_dontcare_transfer(sk2, sk);
+ 	/* Also flush delayed acks to prevent unnecessary retransmission. */
+ 	if(sk2->ack_backlog)
+ 		tcp_send_ack(sk2);
+ 	if(sk->ack_backlog)
+ 		tcp_send_ack(sk);
+ 
+ 	/*
+ 	 * Release_sock() causes us to bridge whatever is on our back_log.
+ 	 * It is OK to transmit these out of order...  The sender handles
+ 	 * any necessary retransmissions.
+ 	 *
+ 	 * Do the release_sock() last.  If tcp_dontcare_cleanup() cleans
+ 	 * up the socks, the TIME_DONE timer still prevents us from
+ 	 * destroying them (at least this one) because we still have the
+ 	 * sock locked.  And tcp_dontcare_cleanup() is modified to bridge
+ 	 * out any backlogged packets on socks it cleans up because we do
+ 	 * not want to continue processing backlogs of socks that can be
+ 	 * destroyed by TIME_DONE at any time.
+ 	 */
+ 	tcp_dontcare_cleanup(sk, 0);	/* works on both socks */
+ 	release_sock(sk2);
+ 	release_sock(sk);
+ 	return 0;
+ }
+ 
  int tcp_ioctl(struct sock *sk, int cmd, unsigned long arg)
  {
  	int err;
***************
*** 790,795 ****
--- 1192,1229 ----
  			put_user(amount, (int *)arg);
  			return(0);
  		}
+ 		case SIOCSLISTEN: /* set the global listening socket */
+ 		{
+ 			if (sk->state == TCP_LISTEN) {
+ 				/* turn on TCP scanning */
+ 				if (TCP_scansock)
+ 					return(-EADDRINUSE);
+ 				/* This becomes the global TCP scanner. */
+ 				sk->max_ack_backlog = 250;
+ 				TCP_scansock = sk;
+ 			} else {
+ 				/* turn off TCP scanning */
+ 				if (!TCP_scansock)
+ 					return(-EINVAL);
+ 				TCP_scansock = NULL;
+ 			}
+ 			return(0);
+ 		}
+ 		case SIOCSCANPAIR: /* accept the server sock of the pair */
+ 		{
+ 			return(tcp_scan_accept(sk));
+ 		}
+ 		case SIOCSDONTCARE: /* do not care about this connection */
+ 		{
+ 			return(tcp_scan_dontcare(sk));
+ 		}
+ 		case SIOCSINTERNAL: /* connection initiated from inside */
+ 		{
+ 			if (!sk->scandev)
+ 				return(-EINVAL);
+ 			/* return 1 if started from the internal interface */
+ 			return( (sk->scandev->internal) ? 1 : 0);
+ 		}
  		default:
  			return(-EINVAL);
  	}
***************
*** 1587,1592 ****
--- 2021,2027 ----
  
  		skb->used = 1;
  		sk->shutdown |= RCV_SHUTDOWN;
+ 		sk->finflag = 1;
  		break;
  
  	}
***************
*** 1619,1625 ****
   *	closed.
   */
  
! static int tcp_close_state(struct sock *sk, int dead)
  {
  	int ns=TCP_CLOSE;
  	int send_fin=0;
--- 2054,2060 ----
   *	closed.
   */
  
! int tcp_close_state(struct sock *sk, int dead)
  {
  	int ns=TCP_CLOSE;
  	int send_fin=0;
***************
*** 1646,1651 ****
--- 2081,2088 ----
  			send_fin=1;
  	}
  
+ 	if (ns == TCP_CLOSE)
+ 		tcp_preclose(sk);
  	tcp_set_state(sk,ns);
  
  	/*
***************
*** 1742,1748 ****
  }
  
  
! static void tcp_close(struct sock *sk, unsigned long timeout)
  {
  	struct sk_buff *skb;
  
--- 2179,2185 ----
  }
  
  
! void tcp_close(struct sock *sk, unsigned long timeout)
  {
  	struct sk_buff *skb;
  
***************
*** 1752,1762 ****
--- 2189,2241 ----
  	 */
  
  	lock_sock(sk);
+ 	log_sockevent(sk, 5, sk->write_seq, sk->copied_seq);
  
  	tcp_cache_zap();
+ 
+ 	if(TCP_scansock && sk == TCP_scansock) {
+ 		TCP_scansock = NULL;
+ 	}
+ 
+ 	/*
+ 	 * Dontcare socks do not want tcp_close to change the state.
+ 	 * tcp_close() should deaden it, dontcare_cleanup() should put
+ 	 * it in TCP_CLOSE state and put it on the TIME_DONE timer.
+ 	 * TIME_DONE will not destroy the sock until it is dead and closed.
+ 	 */
+ 	if(sk->dontcare)
+ 	{
+ 		/* Do the release_sock() before marking dead because we
+ 		 * do not want TIME_DONE to fire while processing the backlog.
+ 		 */
+ 		release_sock(sk);
+ 		sk->dead = 1;
+ 		return;
+ 	}
+ 
+ 	if(sk->scanpair) {
+ 		struct sock *sk2 = sk->scanpair;
+ 
+ 		sk->scanpair = 0;
+ 		sk2->scanpair = 0;
+ 		if(sk->scanclient && !sk2->scanaccepted) {
+ 			/* Our unaccepted partner would be lost without us */
+ 			/* This mimics the "close a listening sock" code */
+ 			tcp_close(sk2, 0);
+ 			if (!sk2->dead) {
+ 				printk("tcp_close: sk2 not marked dead\n");
+ 				sk2->dead = 1;
+ 			}
+ 		} else if(!sk->scanclient && !sk->scanaccepted) {
+ 			printk("tcp_close: closing unaccepted sock\n");
+ 			sk->dead = 1;
+ 		}
+ 	}
+ 
  	if(sk->state == TCP_LISTEN)
  	{
  		/* Special case */
+ 		tcp_preclose(sk);
  		tcp_set_state(sk, TCP_CLOSE);
  		tcp_close_pending(sk);
  		release_sock(sk);
***************
*** 2173,2181 ****
  }
  
  
  struct proto tcp_prot = {
  	tcp_close,
! 	ip_build_header,
  	tcp_connect,
  	tcp_accept,
  	ip_queue_xmit,
--- 2652,2753 ----
  }
  
  
+ #if 0
+ /*
+  * There are two sets of rules involved with packet data: incoming, outgoing.
+  * 
+  * Incoming has skb->mac.ethernet pointing to the MAC header and skb->data
+  * pointing to TCP data (as pulled up in tcp_rcv()).  It also has skb->h.raw
+  * (including iph and th) pointing to the TCP header (as set by ip_rcv()).
+  * In fact, that is how far it knows to pullup to get to TCP data, h.raw-data.
+  * And it has skb->ip_hdr pointing to the IP header.
+  * skb->head (the true start of skb) should match skb->mac.raw.
+  * 
+  * Outgoing has skb->data pointing to the MAC header (as pushed by
+  * eth_header()).  It does not have skb->mac.raw or skb->h.raw set.
+  * Also, skb->data is not likely to be skb->head since ip_build_header()
+  * calls ip_send_room() which reserves MAX_HEADER (32) before pushing just
+  * enough to hold the header (14) (alternatively, eth_header() if
+  * ip_build_header() finds no route).
+  * 
+  * This routine wants to find the MAC header since all the rest is contiguous.
+  * It prints a TCP packet either arriving or being sent.
+  * This is actually pretty handy.
+  */
+ void p_pkt(struct sk_buff *skb, struct device *dev, int outgoing)
+ {
+ 	unsigned char *data;
+ 	unsigned char *p1, *p2;
+ 	unsigned short *sp;
+ 	int i;
+ 
+ 	if (dev) {
+ 		p1 = dev->dev_addr;
+ 		printk("%s device %s, %02x:%02x:%02x:%02x:%02x:%02x\n",
+ 			(outgoing) ? "out to" : "in from", dev->name,
+ 			p1[0], p1[1], p1[2], p1[3], p1[4], p1[5]);
+ 	} else {
+ 		printk("%s some device\n", (outgoing) ? "out to" : "in from");
+ 	}
+ 	data = (outgoing) ? skb->data : skb->mac.raw;
+ 	p1 = &data[6]; /* eth->h_source */
+ 	p2 = &data[0]; /* eth->h_dest */
+ 	printk(
+ 	"  %02x:%02x:%02x:%02x:%02x:%02x to %02x:%02x:%02x:%02x:%02x:%02x\n",
+ 		p1[0], p1[1], p1[2], p1[3], p1[4], p1[5],
+ 		p2[0], p2[1], p2[2], p2[3], p2[4], p2[5]);
+ 
+ 	sp = (unsigned short *)(data + dev->hard_header_len);
+ 	for(i=0; i<48; i+=16) {
+ 		printk("  %04x %04x  %04x %04x  %04x %04x  %04x %04x\n",
+ 			ntohs(sp[0]), ntohs(sp[1]), ntohs(sp[2]), ntohs(sp[3]),
+ 			ntohs(sp[4]), ntohs(sp[5]), ntohs(sp[6]), ntohs(sp[7]));
+ 		sp += 8;
+ 	}
+ }
+ 
+ /* my_ip_queue_xmit() is substituted for ip_queue_xmit() below. */
+ void my_ip_queue_xmit(struct sock *sk, struct device *dev,
+ 			struct sk_buff *skb, int free)
+ {
+ 	if(sk && sk->scanpair) p_pkt(skb, dev, 1);
+ 	ip_queue_xmit(sk, dev, skb, free);
+ }
+ /* usually, the #if 0 is placed above p_pkt(). */
+ #endif 0
+ 
+ /*
+  * Replace ip_build_header() in the tcp_proto proto structure so that
+  * we do not rely on standard routing.  Set *dev explicitly.
+  * I see that in all cases but one (tcp_reset), the skb->sk field is
+  * set before calling prot->build_header().  This lets me identify
+  * which requests can be handled here.
+  */
+ int my_build_header(struct sk_buff *skb, __u32 saddr, __u32 daddr,
+ 		struct device **dev, int type, struct options *opt,
+ 		int len, int tos, int ttl, struct rtable **rp)
+ {
+ 	if(skb->sk && skb->sk->scandev) {
+ 		*dev = skb->sk->scandev;
+ 		/*
+ 		 * Identify the device not to forward the packet on.
+ 		 * I cannot simply use skb->sk->scanpair->scandev because
+ 		 * connection termination causes scanpairs to go away.
+ 		 * This can lead to duplicate FIN packets on a LAN.
+ 		 * I also cannot simply use skb->dev because it gets
+ 		 * overwritten as the outgoing interface on its way down.
+ 		 * The sk->indev field is a kludge, but it should work.
+ 		 */
+ 		skb->indev = skb->sk->indev;
+ 	}
+ 	return(ip_build_header(skb, saddr, daddr,
+ 		dev, type, opt, len, tos, ttl, rp));
+ }
+ 
+ 
  struct proto tcp_prot = {
  	tcp_close,
! 	my_build_header,
  	tcp_connect,
  	tcp_accept,
  	ip_queue_xmit,
